--- WARNING: THIS IS AN AUTO-GENERATED FILE, DO NOT EDIT. PLEASE MODIFY THE ORIGINAL SOURCE IN THE 'https://github.com/istio/istio' REPO source_repo: https://github.com/istio/istio title: pilot-discovery description: Istio Pilot. generator: pkg-collateral-docs number_of_entries: 5 ---

Istio Pilot provides fleet-wide traffic management capabilities in the Istio Service Mesh.

Flags | Description
--- | ---
`--ctrlz_address <string>` | The IP Address to listen on for the ControlZ introspection facility. Use '*' to indicate all addresses. (default `localhost`)
`--ctrlz_port <uint16>` | The IP port to use for the ControlZ introspection facility (default `9876`)
`--keepaliveInterval <duration>` | The time interval if no activity on the connection it pings the peer to see if the transport is alive (default `30s`)
`--keepaliveMaxServerConnectionAge <duration>` | Maximum duration a connection will be kept open on the server before a graceful close. (default `2562047h47m16.854775807s`)
`--keepaliveTimeout <duration>` | After having pinged for keepalive check, the client/server waits for a duration of keepaliveTimeout and if no activity is seen even after that the connection is closed. (default `10s`)
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, all, authn, default, mcp, model, rbac] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, authn, default, mcp, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, all, authn, default, mcp, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)

## pilot-discovery discovery

Start Istio proxy discovery service.

    pilot-discovery discovery [flags]

Flags | Shorthand | Description
--- | --- | ---
`--appNamespace <string>` | `-a` | Restrict the applications namespace the controller manages; if not set, controller watches all namespaces (default ``)
`--clusterRegistriesNamespace <string>` |  | Namespace for ConfigMap which stores clusters configs (default ``)
`--configDir <string>` |  | Directory to watch for updates to config yaml files. If specified, the files will be used as the source of config, rather than a CRD client. (default ``)
`--consulserverInterval <duration>` |  | Interval (in seconds) for polling the Consul service registry (default `2s`)
`--consulserverURL <string>` |  | URL for the Consul server (default ``)
`--ctrlz_address <string>` |  | The IP Address to listen on for the ControlZ introspection facility. Use '*' to indicate all addresses. (default `localhost`)
`--ctrlz_port <uint16>` |  | The IP port to use for the ControlZ introspection facility (default `9876`)
`--disable-install-crds` |  | Disable discovery service from verifying the existence of CRDs at startup and then installing if not detected. It is recommended to be disable for highly available setups.
`--discoveryCache` |  | Enable caching discovery service responses
`--domain <string>` |  | DNS domain suffix (default `cluster.local`)
`--grpcAddr <string>` |  | Discovery service grpc address (default `:15010`)
`--httpAddr <string>` |  | Discovery service HTTP address (default `:8080`)
`--keepaliveInterval <duration>` |  | The time interval if no activity on the connection it pings the peer to see if the transport is alive (default `30s`)
`--keepaliveMaxServerConnectionAge <duration>` |  | Maximum duration a connection will be kept open on the server before a graceful close. (default `2562047h47m16.854775807s`)
`--keepaliveTimeout <duration>` |  | After having pinged for keepalive check, the client/server waits for a duration of keepaliveTimeout and if no activity is seen even after that the connection is closed. (default `10s`)
`--kubeconfig <string>` |  | Use a Kubernetes configuration file instead of in-cluster configuration (default ``)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, all, authn, default, mcp, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, authn, default, mcp, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, all, authn, default, mcp, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--mcpInitialConnWindowSize <int>` |  | Initial connection window size for MCP's gRPC connection (default `1048576`)
`--mcpInitialWindowSize <int>` |  | Initial window size for MCP's gRPC connection (default `1048576`)
`--mcpMaxMsgSize <int>` |  | Max message size received by MCP's grpc client (default `4194304`)
`--meshConfig <string>` |  | File name for Istio mesh configuration. If not specified, a default mesh will be used. (default `/etc/istio/config/mesh`)
`--monitoringAddr <string>` |  | HTTP address to use for pilot's self-monitoring information (default `:15014`)
`--namespace <string>` | `-n` | Select a namespace where the controller resides. If not set, uses ${POD_NAMESPACE} environment variable (default ``)
`--networksConfig <string>` |  | File name for Istio mesh networks configuration. If not specified, a default mesh networks will be used. (default `/etc/istio/config/meshNetworks`)
`--plugins <stringSlice>` |  | comma separated list of networking plugins to enable (default `[authn,authz,health,mixer]`)
`--profile` |  | Enable profiling via web interface host:port/debug/pprof
`--registries <stringSlice>` |  | Comma separated list of platform service registries to read from (choose one or more from {Kubernetes, Consul, MCP, Mock}) (default `[Kubernetes]`)
`--resync <duration>` |  | Controller resync interval (default `1m0s`)
`--secureGrpcAddr <string>` |  | Discovery service grpc address, with https (default `:15012`)
`--trust-domain <string>` |  | The domain serves to identify the system with spiffe (default ``)

## pilot-discovery request

Makes an HTTP request to Pilot metrics/debug endpoint

    pilot-discovery request <method> <path> [<body>] [flags]

Flags | Description
--- | ---
`--ctrlz_address <string>` | The IP Address to listen on for the ControlZ introspection facility. Use '*' to indicate all addresses. (default `localhost`)
`--ctrlz_port <uint16>` | The IP port to use for the ControlZ introspection facility (default `9876`)
`--keepaliveInterval <duration>` | The time interval if no activity on the connection it pings the peer to see if the transport is alive (default `30s`)
`--keepaliveMaxServerConnectionAge <duration>` | Maximum duration a connection will be kept open on the server before a graceful close. (default `2562047h47m16.854775807s`)
`--keepaliveTimeout <duration>` | After having pinged for keepalive check, the client/server waits for a duration of keepaliveTimeout and if no activity is seen even after that the connection is closed. (default `10s`)
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, all, authn, default, mcp, model, rbac] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, authn, default, mcp, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, all, authn, default, mcp, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)

## pilot-discovery version

Prints out build version information

    pilot-discovery version [flags]

Flags | Shorthand | Description
--- | --- | ---
`--ctrlz_address <string>` |  | The IP Address to listen on for the ControlZ introspection facility. Use '*' to indicate all addresses. (default `localhost`)
`--ctrlz_port <uint16>` |  | The IP port to use for the ControlZ introspection facility (default `9876`)
`--keepaliveInterval <duration>` |  | The time interval if no activity on the connection it pings the peer to see if the transport is alive (default `30s`)
`--keepaliveMaxServerConnectionAge <duration>` |  | Maximum duration a connection will be kept open on the server before a graceful close. (default `2562047h47m16.854775807s`)
`--keepaliveTimeout <duration>` |  | After having pinged for keepalive check, the client/server waits for a duration of keepaliveTimeout and if no activity is seen even after that the connection is closed. (default `10s`)
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [ads, all, authn, default, mcp, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, authn, default, mcp, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [ads, all, authn, default, mcp, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--output <string>` | `-o` | One of 'yaml' or 'json'. (default ``)
`--short` | `-s` | Use --short=false to generate full version information

## Environment variables

These environment variables affect the behavior of the `pilot-discovery` command.

Variable Name | Type | Default Value | Description
--- | --- | --- | ---
`ISTIO_GPRC_MAXSTREAMS` | Integer | `100000` | Sets the maximum number of concurrent grpc streams.
`K8S_INGRESS_NS` | String | `` |
`PILOT_CERT_DIR` | String | `` |
`PILOT_DEBOUNCE_AFTER` | Time Duration | `100ms` | The delay added to config/registry events for debouncing. This will delay the push by at least this internal. If no change is detected within this period, the push will happen, otherwise we'll keep delaying until things settle, up to a max of PILOT_DEBOUNCE_MAX.
`PILOT_DEBOUNCE_MAX` | Time Duration | `10s` | The maximum amount of time to wait for events while debouncing. If events keep showing up with no breaks for this time, we'll trigger a push.
`PILOT_DEBUG_ADSZ_CONFIG` | Boolean | `false` |
`PILOT_DISABLE_XDS_MARSHALING_TO_ANY` | Boolean | `false` |
`PILOT_ENABLE_EDS_DEBOUNCE` | Boolean | `true` | If enabled, Pilot will include EDS pushes in the push debouncing, configured by PILOT_DEBOUNCE_AFTER and PILOT_DEBOUNCE_MAX. EDS pushes may be delayed, but there will be fewer pushes. By default this is enabled
`PILOT_ENABLE_FALLTHROUGH_ROUTE` | Boolean | `true` | EnableFallthroughRoute provides an option to add a final wildcard match for routes. When ALLOW_ANY traffic policy is used, a Passthrough cluster is used. When REGISTRY_ONLY traffic policy is used, a 502 error is returned.
`PILOT_ENABLE_HEADLESS_SERVICE_POD_LISTENERS` | Boolean | `true` | If enabled, for a headless service/stateful set in Kubernetes, pilot will generate an outbound listener for each pod in a headless service. This feature should be disabled if headless services have a large number of pods.
`PILOT_ENABLE_MYSQL_FILTER` | Boolean | `false` | EnableMysqlFilter enables injection of `envoy.filters.network.mysql_proxy` in the filter chain.
`PILOT_ENABLE_PROTOCOL_SNIFFING_FOR_INBOUND` | Boolean | `false` | If enabled, protocol sniffing will be used for inbound listeners whose port protocol is not specified or unsupported
`PILOT_ENABLE_PROTOCOL_SNIFFING_FOR_OUTBOUND` | Boolean | `true` | If enabled, protocol sniffing will be used for outbound listeners whose port protocol is not specified or unsupported
`PILOT_ENABLE_REDIS_FILTER` | Boolean | `false` | EnableRedisFilter enables injection of `envoy.filters.network.redis_proxy` in the filter chain.
`PILOT_HTTP10` | Boolean | `false` | Enables the use of HTTP 1.0 in the outbound HTTP listeners, to support legacy applications.
`PILOT_INBOUND_PROTOCOL_DETECTION_TIMEOUT` | Time Duration | `1s` | Protocol detection timeout for inbound listener
`PILOT_INITIAL_FETCH_TIMEOUT` | Time Duration | `0s` | Specifies the initial_fetch_timeout for config. If this time is reached without a response to the config requested by Envoy, the Envoy will move on with the init phase. This prevents envoy from getting stuck waiting on config during startup.
`PILOT_PUSH_THROTTLE` | Integer | `100` | Limits the number of concurrent pushes allowed. On larger machines this can be increased for faster pushes
`PILOT_RESPECT_DNS_TTL` | Boolean | `true` | If enabled, DNS based clusters will respect the TTL of the DNS, rather than polling at a fixed rate. This option is only provided for backward compatibility purposes and will be removed in the near future.
`PILOT_RESTRICT_POD_UP_TRAFFIC_LOOP` | Boolean | `true` | If enabled, this will block inbound traffic from matching outbound listeners, which could result in an infinite loop of traffic. This option is only provided for backward compatibility purposes and will be removed in the near future.
`PILOT_SCOPE_GATEWAY_TO_NAMESPACE` | Boolean | `false` | If enabled, a gateway workload can only select gateway resources in the same namespace. Gateways with same selectors in different namespaces will not be applicable.
`PILOT_SCOPE_PUSHES` | Boolean | `true` | If enabled, pilot will attempt to limit unnecessary pushes by determining what proxies a config or endpoint update will impact.
`PILOT_SIDECAR_USE_REMOTE_ADDRESS` | Boolean | `false` | UseRemoteAddress sets useRemoteAddress to true for side car outbound listeners.
`PILOT_SKIP_VALIDATE_TRUST_DOMAIN` | Boolean | `false` | Skip validating the peer is from the same trust domain when mTLS is enabled in authentication policy
`PILOT_TRACE_SAMPLING` | Floating-Point | `100` | Sets the mesh-wide trace sampling percentage. Should be 0.0 - 100.0. Precision to 0.01. Default is 100, not recommended for production use.
`POD_NAME` | String | `` |
`POD_NAMESPACE` | String | `` |
`TERMINATION_DRAIN_DURATION_SECONDS` | Integer | `5` | The amount of time allowed for connections to complete on pilot-agent shutdown. On receiving SIGTERM or SIGINT, pilot-agent tells the active Envoy to start draining, preventing any new connections and allowing existing connections to complete. It then sleeps for the TerminationDrainDuration and then kills any remaining active Envoy processes.
`USE_ISTIO_JWT_FILTER` | Boolean | `false` | Use the Istio JWT filter for JWT token verification.

## Exported metrics

Metric Name | Type | Description
--- | --- | ---
`endpoint_no_pod` | `LastValue` | Endpoints without an associated pod.
`istio_build` | `LastValue` | Istio component build info
`istio_mcp_clients_total` | `LastValue` | The number of streams currently connected.
`istio_mcp_message_sizes_bytes` | `Distribution` | Size of messages received from clients.
`istio_mcp_reconnections` | `Sum` | The number of times the sink has reconnected.
`istio_mcp_recv_failures_total` | `Sum` | The number of recv failures in the source.
`istio_mcp_request_acks_total` | `Sum` | The number of request acks received by the source.
`istio_mcp_request_nacks_total` | `Sum` | The number of request nacks received by the source.
`istio_mcp_send_failures_total` | `Sum` | The number of send failures in the source.
`pilot_conflict_inbound_listener` | `LastValue` | Number of conflicting inbound listeners.
`pilot_conflict_outbound_listener_http_over_current_tcp` | `LastValue` | Number of conflicting wildcard http listeners with current wildcard tcp listener.
`pilot_conflict_outbound_listener_tcp_over_current_http` | `LastValue` | Number of conflicting wildcard tcp listeners with current wildcard http listener.
`pilot_conflict_outbound_listener_tcp_over_current_tcp` | `LastValue` | Number of conflicting tcp listeners with current tcp listener.
`pilot_destrule_subsets` | `LastValue` | Duplicate subsets across destination rules for same host
`pilot_discovery_calls` | `Sum` | Individual method calls in Pilot
`pilot_discovery_errors` | `Sum` | Errors encountered during a given method call within Pilot
`pilot_discovery_resources` | `Distribution` | Returned resource counts per method by Pilot
`pilot_duplicate_envoy_clusters` | `LastValue` | Duplicate envoy clusters caused by service entries with same hostname
`pilot_eds_no_instances` | `LastValue` | Number of clusters without instances.
`pilot_endpoint_not_ready` | `LastValue` | Endpoint found in unready state.
`pilot_inbound_updates` | `Sum` | Total number of updates received by pilot.
`pilot_invalid_out_listeners` | `LastValue` | Number of invalid outbound listeners.
`pilot_jwks_resolver_network_fetch_fail_total` | `Sum` | Total number of failed network fetch by pilot jwks resolver
`pilot_jwks_resolver_network_fetch_success_total` | `Sum` | Total number of successfully network fetch by pilot jwks resolver
`pilot_k8s_cfg_events` | `Sum` | Events from k8s config.
`pilot_k8s_object_errors` | `LastValue` | Errors converting k8s CRDs
`pilot_k8s_reg_events` | `Sum` | Events from k8s registry.
`pilot_no_ip` | `LastValue` | Pods not found in the endpoint table, possibly invalid.
`pilot_proxy_convergence_time` | `Distribution` | Delay between config change and all proxies converging.
`pilot_proxy_queue_time` | `Distribution` | Time a proxy is in the push queue before being dequeued.
`pilot_rds_expired_nonce` | `Sum` | Total number of RDS messages with an expired nonce.
`pilot_services` | `LastValue` | Total services known to pilot.
`pilot_total_rejected_configs` | `Sum` | Total number of configs that Pilot had to reject or ignore.
`pilot_total_xds_internal_errors` | `Sum` | Total number of internal XDS errors in pilot.
`pilot_total_xds_rejects` | `Sum` | Total number of XDS responses from pilot rejected by proxy.
`pilot_virt_services` | `LastValue` | Total virtual services known to pilot.
`pilot_vservice_dup_domain` | `LastValue` | Virtual services with dup domains.
`pilot_xds` | `LastValue` | Number of endpoints connected to this pilot using XDS.
`pilot_xds_cds_reject` | `LastValue` | Pilot rejected CSD configs.
`pilot_xds_eds_instances` | `LastValue` | Instances for each cluster, as of last push. Zero instances is an error.
`pilot_xds_eds_reject` | `LastValue` | Pilot rejected EDS.
`pilot_xds_lds_reject` | `LastValue` | Pilot rejected LDS.
`pilot_xds_push_context_errors` | `Sum` | Number of errors (timeouts) initiating push context.
`pilot_xds_pushes` | `Sum` | Pilot build and send errors for lds, rds, cds and eds.
`pilot_xds_rds_reject` | `LastValue` | Pilot rejected RDS.
`pilot_xds_write_timeout` | `Sum` | Pilot XDS response write timeouts.